"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _toollib = require("./common/toollib");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

/**
* 基于数组实现的数据结构的基类
*
* @class ArrayBasedStruct
*/
var ArrayBasedStruct = /*#__PURE__*/function () {
  function ArrayBasedStruct() {
    _classCallCheck(this, ArrayBasedStruct);

    this.__items = [];
  }
  /**
   * 获取所有元素
   *
   * @returns 元素集合
   * @memberof Stack
   */


  _createClass(ArrayBasedStruct, [{
    key: "getItems",
    value: function getItems() {
      return (0, _toollib.deepCopy)(this.__items);
    }
    /**
     * 数据结构实例中是否包含元素
     *
     * @readonly
     * @memberof ArrayBasedStruct
     */

  }, {
    key: "isEmpty",
    get: function get() {
      return this.__items.length === 0;
    }
    /**
     * 数据结构实例的元素个数
     *
     * @readonly
     * @memberof ArrayBasedStruct
     */

  }, {
    key: "size",
    get: function get() {
      return this.__items.length;
    }
    /**
     * 清空数据结构中的元素
     *
     * @memberof ArrayBasedStruct
     */

  }, {
    key: "clear",
    value: function clear() {
      this.__items.length = 0;
    }
  }]);

  return ArrayBasedStruct;
}();

var _default = ArrayBasedStruct;
exports["default"] = _default;